package org.jeecg.modules.ctop.job;

import cn.com.ctop.kuaishou.modules.graphql.service.IKuaishouWebInterfaceService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.jeecg.modules.ctop.entity.BindAccountLogin;
import org.jeecg.modules.ctop.service.IBindAccountLoginService;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.HashMap;
import java.util.List;

public class KuaishouCommentAutoDelete implements Job {
    @Autowired
    private IKuaishouWebInterfaceService kuaishouWebInterfaceService;
    @Autowired
    private IBindAccountLoginService bindAccountLoginService;

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        QueryWrapper<BindAccountLogin> queryWrapper = new QueryWrapper<BindAccountLogin>();
        queryWrapper.eq("login_type", "kuaishou");
        queryWrapper.eq("status", 1);
        List<BindAccountLogin> list = bindAccountLoginService.list(queryWrapper);
        if (list != null && list.size() > 0) {
            for (BindAccountLogin account : list) {
                try {
                    System.out.println("正在删除评论：" + account.getAccountName());
                    kuaishouWebInterfaceService.adkuaishouWebLogin(account.getAccountName(), account.getPassword());
                    kuaishouWebInterfaceService.deleteAllComment(new HashMap<>());
                    Thread.sleep(10000);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }
}
