package org.jeecg.modules.ctop.service.impl;

import cn.com.ctop.common.utils.Check;
import org.jeecg.modules.ctop.entity.CTopOauthToken;
import org.jeecg.modules.ctop.mapper.CTopOauthTokenMapper;
import org.jeecg.modules.ctop.service.ICTopOauthTokenService;
import org.jeecg.modules.ctop.service.IRefreshTokenService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class RefreshTokenServiceImpl implements IRefreshTokenService {
    private static final Logger logger = LoggerFactory.getLogger(RefreshTokenServiceImpl.class);
    @Autowired
    private CTopOauthTokenMapper oauthTokenMapper;
    @Autowired
    private ICTopOauthTokenService oauthTokenService;

    /**
     * 获取所有token
     *
     * @return
     */
    @Override
    public void getRefresh() {
        List<CTopOauthToken> oauthTokens = oauthTokenMapper.selectAll();
        logger.info("需要刷新token列表长度:{}", oauthTokens.size());
        if (!Check.isNull(oauthTokens)) {
            for (CTopOauthToken oauthToken : oauthTokens) {
                if ("1".equals(oauthToken.getMediaId().trim())) { //头条
                    oauthTokenService.getByteDanceAccessToken(String.valueOf(oauthToken.getAccountId()));
                }
                if ("2".equals(oauthToken.getMediaId().trim())) { //快手
                    oauthTokenService.getKuaiShouRefreshToken(oauthToken.getAccountId(), oauthToken.getRefreshToken());
                }

            }
        } else {
            logger.error("----------------------刷新token获取数据返回结果为空----------------------------------");
        }
    }
}
