package org.jeecg.modules.kuaishou.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @Description: 快手-上传视频
 * @Author: jeecg-boot
 * @Date: 2019-08-06
 * @Version: V1.0
 */
@Data
@TableName("ctop_kuaishou_video")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_kuaishou_video对象", description = "快手-上传视频")
public class KuaiShouVideo {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Integer id;
    /**
     * 视频保存本地地址
     */
    @Excel(name = "视频保存本地地址", width = 15)
    @ApiModelProperty(value = "视频保存本地地址")
    private Object localUrl;
    /**
     * 视频描述
     */
    @Excel(name = "视频描述", width = 15)
    @ApiModelProperty(value = "视频描述")
    private Object videoDesc;
    /**
     * videoName
     */
    @Excel(name = "videoName", width = 15)
    @ApiModelProperty(value = "videoName")
    private String videoName;
    /**
     * 视频类别
     */
    @Excel(name = "视频类别", width = 15)
    @ApiModelProperty(value = "视频类别")
    private String videoType;
    /**
     * 登录人id
     */
    @Excel(name = "登录人id", width = 15)
    @ApiModelProperty(value = "登录人id")
    private String loginId;
    /**
     * 创建时间
     */
    @Excel(name = "创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @Excel(name = "修改时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
    /**
     * createBy
     */
    @Excel(name = "createBy", width = 15)
    @ApiModelProperty(value = "createBy")
    private String createBy;
    /**
     * updateBy
     */
    @Excel(name = "updateBy", width = 15)
    @ApiModelProperty(value = "updateBy")
    private String updateBy;
}
