package org.jeecg.modules.kuaishou.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.jeecg.modules.kuaishou.entity.KuaiShouGroupCreateTemplate;
import org.jeecg.modules.kuaishou.mapper.KuaiShouGroupCreateTemplateMapper;
import org.jeecg.modules.kuaishou.service.IKuaiShouGroupCreateTemplateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 快手-创建广告组信息模板
 * @Author: jeecg-boot
 * @Date: 2019-08-07
 * @Version: V1.0
 */
@Service
public class KuaiShouGroupCreateTemplateServiceImpl extends ServiceImpl<KuaiShouGroupCreateTemplateMapper, KuaiShouGroupCreateTemplate> implements IKuaiShouGroupCreateTemplateService {

    @Autowired
    private KuaiShouGroupCreateTemplateMapper groupCreateMapper;

    @Override
    public Map<String, Object> insert(KuaiShouGroupCreateTemplate groupCreateTemplate) {
        Map<String, Object> resultMap = new HashMap<>();
        try {
            groupCreateMapper.insert(groupCreateTemplate);
            resultMap.put("success", true);
            resultMap.put("message", "创建广告组成功");
            resultMap.put("code", 0);
        } catch (Exception e) {
            resultMap.put("success", false);
            resultMap.put("message", "创建广告组失败");
            resultMap.put("code", -1);
        }
        return resultMap;
    }
}
